#include "aboutdialog.h"
#include "ui_aboutdialog.h"
#include <QSettings>
#include "QMessageBox"
#include <QtCore/QFile>
#include <QDir>
#include <QTextStream>

AboutDialog::AboutDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::AboutDialog)
{
    ui->setupUi(this);

    //Procitaj i postavi jezik
    QSettings temp_settings("glrp", "Great Little Radio Player");
    temp_settings.beginGroup("OtherSettings");
    ReadLanguage(temp_settings.value("UILanguage", "English").toString());
    temp_settings.endGroup();
    //-----------------------
    setWindowTitle(QString::fromUtf8(LangAboutProgram1.toStdString().c_str()) + ": " + QApplication::applicationName());

    SetupThis();
}

AboutDialog::~AboutDialog()
{
    delete ui;
}


void AboutDialog::SetupThis()
{
QFile Changelog(QApplication::applicationDirPath() + QDir::separator() + "changelog.txt");

    if (Changelog.exists())
    {
            if(Changelog.open(QIODevice::ReadOnly))
                {
                QTextStream cl( &Changelog );
                ui->label_3->setText(cl.readAll());
                Changelog.close();
            }
       }
    QString Translation = QString("<table width='100%' border='0'><tr><td><font size=3>See on web site</font><br><font color='#6699CC'><a href='https://sites.google.com/site/glrpgreatlittleradioplayer/home/translations'>Application website - Translations section</a></font></td></tr></table>");
    ui->label_6->setText(Translation);
    Changelog.close();

    QString GlavniLabelString = QString("<table width='100%' border='0'><tr><td align='center' width='15%'><img src='" + QString(":/images/IMG/glrp128.png'/><br>") + "</td><td align='justify' width='85%'><font size=5>" + QApplication::applicationName() + "</font><br><font size=2>" + QApplication::applicationVersion() + "</font><br>");
    QString Program = QString("<table width='100%' border='0'><tr><td align='left' width='85%'>" + QString::fromUtf8(LangAboutProgram1b.toStdString().c_str()) + "<br><br><PLAINTEXT>Copyright: 2012-2013 Dejan Petrovic dekiseka.petrovic@gmail.com<br>License: GPL-3.0+</PLAINTEXT><br><a href='https://sites.google.com/site/glrpgreatlittleradioplayer/'>Application website</a></td></tr></table>");
    ui->label_8->setText(GlavniLabelString + Program);

    QString Important = QString("<table width='100%' border='0'><tr><td>" + QString::fromUtf8(LangWhatYouShouldKnow1b.toStdString().c_str()) + QString("</td></tr></table><br><br>"));
    ui->label_2->setText(Important);

    QString Help = QString("<table width='100%' border='0'><tr><td>" + QString::fromUtf8(LangHowCanYouHelp1b.toStdString().c_str()) + "</td></tr></table><br><br>" + "<br><font color='#6699CC'><a href='mailto:dekiseka.petrovic@gmail.com'>Send us feedback: dekiseka.petrovic@gmail.com</a></font>");
    ui->label_5->setText(Help);
}

void AboutDialog::ReadLanguage(QString Language)
{
    //Language Settings - MainWindow
    QString LanguagesPath("/usr/share/glrp/language/");
    QString LanguageFilePath(LanguagesPath + Language);
    QSettings LangSettings(LanguageFilePath, QSettings::IniFormat);

    LangSettings.beginGroup("About");
    LangAboutProgram1b = LangSettings.value("LangAboutProgram1b", "A robust internet radio station streamer. It connects to web sites offering radio streaming and lets you play radio stations directly from that locations.").toString();
    LangAboutProgram1 = LangSettings.value("LangAboutProgram1", "About program").toString();
    LangAboutProgram1a = LangSettings.value("LangAboutProgram1a", "About ").toString();

    LangWhatYouShouldKnow1 = LangSettings.value("LangWhatYouShouldKnow1", "What you should know").toString();
    LangWhatYouShouldKnow1a = LangSettings.value("LangWhatYouShouldKnow1a", "What you should know about ").toString();
    LangWhatYouShouldKnow1b = LangSettings.value("LangWhatYouShouldKnow1b", "<ul><li>The internet radio station collection is large, but that is not the most important thing with a program like this. You can have a lot of fun using Great Little Radio Player even with just a few stations.</li><li>Sometimes when you want to listen to a station, you may experience some problems. It may happen that fully valid internet radio address will not work because of poor internet connection, quirks of the net or some cosmic reason. Be patient and try the same station again a while later.</li><li>When you click on a radio station, wait a few seconds for connection to be established. Sometimes there are several internet servers between you and chosen radio station.</li><li>Some internet radio stations have stated their music category, and we used that information to categorize our collection. However, do not take it as absolutely precise, because it is not.</li></ul>").toString();

    LangAboutAuthor1 = LangSettings.value("LangAboutAuthor1", "About author").toString();
    LangAboutAuthor1a = LangSettings.value("LangAboutAuthor1a", "About author of ").toString();

    LangWhatsNew1 = LangSettings.value("LangWhatsNew1", "What's new...").toString();
    LangWhatsNew1a = LangSettings.value("LangWhatsNew1a", "What's new from last version?").toString();
    LangWhatsNew1b = LangSettings.value("LangWhatsNew1b", "<font size=5>What's new from last version?</font><ul><li>Support for other languages!</li><li>Coats interface is improved!</li><liCoats preview is added in Settings.</li><li>Pause.</li><li>Buffer.</li><li>More coats</li><li>Some 'dead' stations are removed.</li></ul>").toString();

    LangHowCanYouHelp1 = LangSettings.value("LangHowCanYouHelp1", "How can you help").toString();
    LangHowCanYouHelp1a = LangSettings.value("LangHowCanYouHelp1a", "How can you help?").toString();
    LangHowCanYouHelp1b = LangSettings.value("LangHowCanYouHelp1b", "<font size=4>How can you help to improove this application?</font><ul><li>Send us ideas and suggestions.</li><li>Send us checked internet radio stations and make our station collection bigger.</li><li>Talk about this application and recommend it to others.</li><li>Send us why you like 'Great Little Radio Player', if you do.</li></ul>").toString();

    LangTranslationsTab = LangSettings.value("LangTranslationsTab", "Translations").toString();

    LangSettings.endGroup();

    ui->tabWidget->setTabText(0,QString::fromUtf8(LangWhatYouShouldKnow1.toStdString().c_str()));
    ui->tabWidget->setTabText(1,QString::fromUtf8(LangWhatsNew1.toStdString().c_str()));
    ui->tabWidget->setTabText(2,QString::fromUtf8(LangHowCanYouHelp1.toStdString().c_str()));
    ui->tabWidget->setTabText(3,QString::fromUtf8(LangTranslationsTab.toStdString().c_str()));
}


void AboutDialog::on_buttonBox_accepted()
{
    close();
}
