#include "adddialog.h"
#include "ui_adddialog.h"
#include "mainwindow.h"
#include "QMessageBox"
#include "phonon/MediaObject"
#include "phonon/AudioOutput"
#include <QtCore/QFile>
#include <QDir>
#include <QTimer>
#include "QTableWidgetItem"
#include <QSettings>
#include <QtCore/QFile>
#include <QDialog>
#include <QFileDialog>

Phonon::MediaObject *TestMusic;
Phonon::AudioOutput *TestAudioOutput;
QTimer *timer;
QTableWidget *TestTableWidget;
QString PathToStationsDir2;
QString PathToStationsFile2;

//------------------------------------------------------------------------------------
AddDialog::AddDialog(QWidget *parent) : QDialog(parent), ui(new Ui::AddDialog)
{
     ui->setupUi(this);

     QSettings temp_settings("glrp", "Great Little Radio Player");
     temp_settings.beginGroup("OtherSettings");
     ReadLanguage(temp_settings.value("UILanguage", "English").toString());
     temp_settings.endGroup();

     AddCancelTriger = false;
         timer = new QTimer(this);
         connect(timer, SIGNAL(timeout()), this, SLOT(ChangePlayingStatus()));

         TestMusic = Phonon::createPlayer(Phonon::MusicCategory,Phonon::MediaSource());
         TestAudioOutput = new Phonon::AudioOutput(Phonon::MusicCategory, this);

         //Tabela
         TestTableWidget = new QTableWidget();

         PathToStationsDir2 = QDir::homePath() + "/.config/glrp/";
         PathToStationsFile2 = PathToStationsDir2 + "stations.csv";


         QFile f( PathToStationsFile2 );
         if (!f.exists())//Ako NE postoji lokalni fajl sa stanicama napravi putanju ka PORTABLE fajlu
            {
             PathToStationsFile2 = QApplication::applicationDirPath() + QDir::separator() + "stations.csv";
             f.setFileName(PathToStationsFile2);

             if (f.exists())
                {
                if( f.open( QIODevice::ReadOnly ) )
                    {
                     QTextStream ts( &f );
                     QList<QStringList> list;
                     int row = 0, col = 0;


                     while( !ts.atEnd() )
                     {
                         list << ts.readLine().split( "," );
                     }

                     f.close();

                     TestTableWidget->setRowCount( list.count() );
                     TestTableWidget->setColumnCount( list[0].count() );

                     TestTableWidget->setUpdatesEnabled( false );
                     foreach( QStringList l, list ){
                         foreach( QString str, l ){

                             if( str.endsWith( '"' ) ) str.chop(1);
                             if( str.startsWith( '"' ) ) str.remove(0,1);
                             TestTableWidget->setItem( row, col++, new QTableWidgetItem( str ));
                         }
                         row++; col=0;
                     }
                     TestTableWidget->setUpdatesEnabled( true );
                 }
         //Kraj Tabele
             }
         }
         else
         {
             if( f.open( QIODevice::ReadOnly ) )
                 {
                  QTextStream ts( &f );
                  QList<QStringList> list;
                  int row = 0, col = 0;


                  while( !ts.atEnd() )
                  {
                      list << ts.readLine().split( "," );
                  }

                  f.close();

                  TestTableWidget->setRowCount( list.count() );
                  TestTableWidget->setColumnCount( list[0].count() );

                  TestTableWidget->setUpdatesEnabled( false );
                  foreach( QStringList l, list ){
                      foreach( QString str, l ){

                          if( str.endsWith( '"' ) ) str.chop(1);
                          if( str.startsWith( '"' ) ) str.remove(0,1);
                          TestTableWidget->setItem( row, col++, new QTableWidgetItem( str ));
                      }
                      row++; col=0;
                  }
                  TestTableWidget->setUpdatesEnabled( true );
              }
      //Kraj Tabele
          }



         ClearFields();


         QString Image("<img src=':/images/IMG/add.png'/>");
         ui->MainLabel->setText("<table><tr><td align=center width='70'>" + QString(Image) + "</td><td align=justify><font size=4>" + QString::fromUtf8(Title.toStdString().c_str()) + "</font><br>" + QString::fromUtf8(Info_a.toStdString().c_str()) + QString::fromUtf8(TestItButtonTextGo.toStdString().c_str()) + QString::fromUtf8(Info_b.toStdString().c_str()) + "</td></tr></table>");
         setWindowTitle(QString::fromUtf8(Title.toStdString().c_str()));

         //ui->buttonBox->setCenterButtons(true);
         ui->buttonBox->clear();

         QPushButton *CancelButton = new QPushButton(QString::fromUtf8(CancelButtonText.toStdString().c_str()));
         CancelButton->setAutoDefault(false);
         connect(CancelButton, SIGNAL(clicked()), this, SLOT(pushButton_clicked()));

         QPushButton *ResetButton = new QPushButton(QString::fromUtf8(ResetButtonText.toStdString().c_str()));
         ResetButton->setDefault(false);
         connect(ResetButton, SIGNAL(clicked()), this, SLOT(ClearFields()));

         QPushButton *AddButton = new QPushButton(QString::fromUtf8(AddButtonText.toStdString().c_str()));
         AddButton->setDefault(true);
         connect(AddButton, SIGNAL(clicked()), this, SLOT(AddButton_clicked()));

         ui->buttonBox->addButton(CancelButton, QDialogButtonBox::RejectRole);
         ui->buttonBox->addButton(ResetButton, QDialogButtonBox::ResetRole);
         ui->buttonBox->addButton(AddButton, QDialogButtonBox::AcceptRole);
}

//------------------------------------------------------------------------------------
AddDialog::~AddDialog()
{
    TestMusic->stop();
    delete ui;
}

//------------------------------------------------------------------------------------
void AddDialog::AddButton_clicked()
{
    //Nadji da li ima zareza u tekstu
    QString Name(ui->StationName_lineEdit->text());
    if (Name.contains(",") != ",")
    {
    if ((!ui->StationName_lineEdit->text().isEmpty()) && (!ui->StationAddress_lineEdit->text().isEmpty()) && (!ui->GenrecomboBox->currentText().isEmpty()) && (!ui->CountryComboBox->currentText().isEmpty()))
            {
            QMessageBox msgBox;
            msgBox.setIcon(QMessageBox::Question);
            QPushButton *savestationButton = msgBox.addButton(QString::fromUtf8(SaveStationButtonText.toStdString().c_str()), QMessageBox::ActionRole);
            QPushButton *CancelButton = msgBox.addButton(QString::fromUtf8(CancelButtonText.toStdString().c_str()), QMessageBox::RejectRole);
            msgBox.setText(QString::fromUtf8(SaveStationDialogText.toStdString().c_str()));

            QString s(ui->StationAddress_lineEdit->text());
            QString startaddress(s.mid(0,25));
            int i = s.length();
            QString endaddress(s.mid((i -5),i));

            msgBox.setInformativeText(QString::fromUtf8(SName.toStdString().c_str()) + ui->StationName_lineEdit->text() + "\n" + QString::fromUtf8(SAddress.toStdString().c_str()) + startaddress + " ... " + endaddress + "\n" + QString::fromUtf8(SGenre.toStdString().c_str()) + ui->GenrecomboBox->currentText() + "\n" + QString::fromUtf8(SRegion.toStdString().c_str()) + ui->CountryComboBox->currentText() + "\n\n" + QString::fromUtf8(SaveStationConfirmDialog.toStdString().c_str()));
            msgBox.setDefaultButton(savestationButton);
            int ret = msgBox.exec();

            if (msgBox.clickedButton() == savestationButton)
                {
                StationName = ui->StationName_lineEdit->text();
                StationAddress = ui->StationAddress_lineEdit->text();
                StationGenre = ui->GenrecomboBox->currentText();
                StationCountry = ui->CountryComboBox->currentText();
                if (ui->FavoritecheckBox->isChecked())FavoriteONOFF = "Favorite";else FavoriteONOFF = "";

                AddCancelTriger = true;

                TestMusic->stop();
                timer->stop();

                close();
                }
            }
        else
            {
             QMessageBox reactMsgBox;
             reactMsgBox.setText(QString::fromUtf8(SaveStationErrorDialogText.toStdString().c_str()));
             reactMsgBox.setInformativeText(QString::fromUtf8(SaveStationErrorDialogInfoText.toStdString().c_str()));
             reactMsgBox.setIcon(QMessageBox::Warning);
             reactMsgBox.exec();
            }
    }
    else
    {
        QMessageBox reactMsgBox;
        reactMsgBox.setText(QString::fromUtf8(NameFieldERROR1.toStdString().c_str()));
        reactMsgBox.setInformativeText(QString::fromUtf8(NameFieldERROR2.toStdString().c_str()));
        reactMsgBox.setIcon(QMessageBox::Critical);
        reactMsgBox.exec();

    }
}
//------------------------------------------------------------------------------------

void AddDialog::pushButton_clicked()
{
    ClearFields();
    close();
}

//------------------------------------------------------------------------------------
void AddDialog::ClearFields()
{
    try
        {
        ui->StationName_lineEdit->setText("");
        ui->StationAddress_lineEdit->setText("");

        QStringList CountryStringList;
        QStringList GenreStringList;

        for (int i = 0; i < TestTableWidget->rowCount(); i++)
            {
            CountryStringList << TestTableWidget->item(i,3)->text();
            GenreStringList << TestTableWidget->item(i,2)->text();
            }

        CountryStringList.sort();
        CountryStringList.removeDuplicates();

        GenreStringList.sort();
        GenreStringList.removeDuplicates();

        ui->CountryComboBox->clear();
        ui->CountryComboBox->addItems(CountryStringList);
        ui->CountryComboBox->setCurrentIndex(0);

        ui->GenrecomboBox->clear();
        ui->GenrecomboBox->addItems(GenreStringList);
        ui->GenrecomboBox->setCurrentIndex(0);

        ui->FavoritecheckBox->setChecked(false);

        ui->LoadFromFileLabel->setText(QString::fromUtf8(LoadFromFileLabel1.toStdString().c_str()));
        ui->label_3->setText(QString::fromUtf8(Adress.toStdString().c_str()));
        ui->labelTestStatus->hide();

        TestMusic->stop();
        timer->stop();
        ui->TestButton->setEnabled(false);
        ui->TestButton->setText(QString::fromUtf8(TestItButtonTextGo.toStdString().c_str()));

        //ui->StationName_lineEdit->setPlaceholderText(QString::fromUtf8(SName.toStdString().c_str()));
        //ui->StationAddress_lineEdit->setPlaceholderText(QString::fromUtf8(SAddress.toStdString().c_str()));
        }
        catch(...){}
}

//------------------------------------------------------------------------------------
void AddDialog::TestStation()
{
    QString string = ui->StationAddress_lineEdit->text();
        QString extension = string.mid(string.length()-3,3);
        if ((extension == "pls") || (extension == "m3u") || (extension == "asx") || (extension == "html"))
        {
            QMessageBox msgBox;
            msgBox.setIcon(QMessageBox::Information);
            msgBox.setText(QString::fromUtf8(ExtensionErrorMSG_a.toStdString().c_str()) + extension + QString::fromUtf8(ExtensionErrorMSG_b.toStdString().c_str()));
            msgBox.exec();
        }
        else
        {
            //Test station before insert
            if (ui->TestButton->text() == QString::fromUtf8(TestItButtonTextGo.toStdString().c_str()))
            {
                TestMusic->stop();

                TestMusic->setCurrentSource(Phonon::MediaSource(ui->StationAddress_lineEdit->text()));
                Phonon::AudioOutput *TestAudioOutput = new Phonon::AudioOutput(Phonon::MusicCategory, this);
                TestMusic->play();
                timer->start(5000);
                ui->TestButton->setText(QString::fromUtf8(TestItButtonTextStop.toStdString().c_str()));
                ui->labelTestStatus->show();
            }
            else
            {
                TestMusic->stop();
                ui->TestButton->setText(QString::fromUtf8(TestItButtonTextGo.toStdString().c_str()));
                ui->labelTestStatus->hide();
            }
        }
}
//------------------------------------------------------------------------------------

void AddDialog::on_TestButton_clicked()
{
    TestStation();
}

//------------------------------------------------------------------------------------
void AddDialog::ChangePlayingStatus()
{
    if (TestMusic->state() == Phonon::PlayingState)
        {
            ui->labelTestStatus->setText(QString::fromUtf8(PlayingStatusText.toStdString().c_str()) + QString("<font color=green>") + QString::fromUtf8(PlayingStatusWorking.toStdString().c_str()) + QString("</font>"));
        }
        else
        {
            ui->labelTestStatus->setText(QString::fromUtf8(PlayingStatusText.toStdString().c_str()) + QString("<font color=red>") + QString::fromUtf8(PlayingStatusNotWorking.toStdString().c_str()) + QString("</font>"));
            TestMusic->stop();
            timer->stop();
            ui->TestButton->setText(QString::fromUtf8(TestItButtonTextGo.toStdString().c_str()));
            ui->TestButton->setEnabled(true);
        }
}

//------------------------------------------------------------------------------------
void AddDialog::on_StationAddress_lineEdit_textChanged(const QString &arg1)
{
ui->labelTestStatus->hide();
for (int i = 0; i < TestTableWidget->rowCount(); i++)
     {
     QString sourcestring(ui->StationAddress_lineEdit->text());
     QString deststring(TestTableWidget->item(i,1)->text());
     int stringletters = sourcestring.mid(0,sourcestring.length()-1).length();
     if (sourcestring.mid(0,stringletters) == deststring.mid(0,stringletters))
         {
         ui->label_3->setText(QString::fromUtf8(Adress.toStdString().c_str()) + QString("<font color=red><i>") + QString::fromUtf8(AdressNotValid.toStdString().c_str()) + QString("</i></font><br>") + QString::fromUtf8(AdressInUse.toStdString().c_str()) + QString(TestTableWidget->item(i,0)->text()) + ".");
         ui->TestButton->setEnabled(false);
                break;
                }
            else
                {
                ui->label_3->setText(QString::fromUtf8(Adress.toStdString().c_str()) + QString("<font color=green><i>") + QString::fromUtf8(AdressValid.toStdString().c_str()) + QString("</i></font>") + QString::fromUtf8(AdressNotInUse.toStdString().c_str()));
                ui->TestButton->setEnabled(true);
                }
            }
}

//------------------------------------------------------------------------------------
void AddDialog::ReadLanguage(QString Language)
{
    //Language Settings - MainWindow
    QString LanguagesPath("/usr/share/glrp/language/");
    QString LanguageFilePath(LanguagesPath + Language);
    QSettings LangSettings(LanguageFilePath, QSettings::IniFormat);

    LangSettings.beginGroup("AddNewStation");
    TestItButtonTextGo = LangSettings.value("TestItButtonTextGo", "Test it...").toString();
    TestItButtonTextStop = LangSettings.value("TestItButtonTextStop","Stop testing").toString();
    Info_a = LangSettings.value("Info_a", "This is Add New Station Dialog. It accept only valid URL. Playlists are not supported. Please, when you testing a station, be sure that you clicked '").toString();
    Info_b = LangSettings.value("Info_b", "' button several times. It is necessary for properly testing station URL.").toString();
    Title = LangSettings.value("AddNewStationTitle", "Add New Station").toString();
    SaveStationButtonText = LangSettings.value("SaveStationButtonText", "Save this station right now").toString();
    SaveStationDialogText = LangSettings.value("SaveStationDialogText", "If you are sure that you want to add new radio station to the collection, and you properly tested it, please confirm.<br>Here is what is going to be stored:").toString();
    SaveStationConfirmDialog = LangSettings.value("SaveStationConfirmDialog", "Do you want to save this station?").toString();
    SaveStationErrorDialogText = LangSettings.value("SaveStationErrorDialogText", "Warning! Some station data is not entered correctly and new station is not saved! Sorry!").toString();
    SaveStationErrorDialogInfoText = LangSettings.value("SaveStationErrorDialogInfoText", "Try insert data in every fields next time, please!").toString();
    ExtensionErrorMSG_a = LangSettings.value("ExtensionErrorMSG_a", "Sorry, extension: '").toString();
    ExtensionErrorMSG_b = LangSettings.value("ExtensionErrorMSG_b", "' is not implemented yet!\nOnly clean single station, no playlists!").toString();
    PlayingStatusText = LangSettings.value("PlayingStatusText", "Station address status: ").toString();
    PlayingStatusWorking = LangSettings.value("PlayingStatusWorking", "Working!").toString();
    PlayingStatusNotWorking = LangSettings.value("PlayingStatusNotWorking","Not Working!").toString();

    Adress = LangSettings.value("Adress","Address: ").toString();
    AdressInUse = LangSettings.value("AdressInUse","Similar or same address is already in use by the following radio station: ").toString();
    AdressNotInUse = LangSettings.value("AdressNotInUse"," (Not in collection).").toString();
    AdressValid = LangSettings.value("AdressValid","Valid").toString();
    AdressNotValid = LangSettings.value("AdressNotValid","Not Valid!").toString();

    SName = LangSettings.value("SName","Name: ").toString();
    SAddress = LangSettings.value("SAddress","Address: ").toString();
    SGenre = LangSettings.value("SGenre","Genre: ").toString();
    SRegion = (LangSettings.value("SRegion","Country/Region: ").toString());

    AddNewStationTabText = LangSettings.value("AddNewStationTabText","Internet Radio Station Informations").toString();

    ui->label_2->setText(QString::fromUtf8(SName.toStdString().c_str()));
    ui->label_3->setText(QString::fromUtf8(SAddress.toStdString().c_str()));
    ui->label_4->setText(QString::fromUtf8(SGenre.toStdString().c_str()));
    ui->label_5->setText(QString::fromUtf8(SRegion.toStdString().c_str()));
    ui->tabWidget->setTabText(0, QString::fromUtf8(AddNewStationTabText.toStdString().c_str()));
    ui->TestButton->setText(QString::fromUtf8(TestItButtonTextGo.toStdString().c_str()));

    CancelButtonText = LangSettings.value("CancelButtonText","Cancel").toString();
    AddButtonText = LangSettings.value("AddButtonText","Add").toString();
    ResetButtonText = LangSettings.value("ResetButtonText","Reset").toString();

    NameFieldERROR1 = LangSettings.value("NameFieldERROR1","ERROR: Name field have a comma sign!").toString();
    NameFieldERROR2 = LangSettings.value("NameFieldERROR2","This is not allowed, remove 'comma' from station name!").toString();

    LoadFromFileLabel1 = LangSettings.value("LoadFromFileLabel1","Load from file: ").toString();
    LoadFromFileLabel2 = LangSettings.value("LoadFromFileLabel2","File: ").toString();
    LangFavorite = LangSettings.value("LangFavorite", "Favorite").toString();
    LangSettings.endGroup();

    ui->LoadFromFileLabel->setText(QString::fromUtf8(LoadFromFileLabel1.toStdString().c_str()));

    LangSettings.beginGroup("MainWindow");
    ui->FavoritecheckBox->setText(QString::fromUtf8(LangFavorite.toStdString().c_str()));
    LangSettings.endGroup();
}

//------------------------------------------------------------------------------------

void AddDialog::on_loadplaylistButton_clicked()
{
    ClearFields();

    QString PlayListfFileName = QFileDialog::getOpenFileName(this, tr("Open PLS file"),"", tr("*.pls playlist file (*.pls)"));

                QFile OpenImportFile(PlayListfFileName);
                if (OpenImportFile.exists())
                {
                    ui->LoadFromFileLabel->setText(QString::fromUtf8(LoadFromFileLabel2.toStdString().c_str()) + PlayListfFileName);
                    QSettings PLSSettings(PlayListfFileName, QSettings::IniFormat);
                    PLSSettings.beginGroup("playlist");
                    QString stanica(PLSSettings.value("File1","").toString());

                    if (stanica != "")
                    {
                        ui->StationAddress_lineEdit->setText(stanica);
                        TestStation();
                    }
                 }
}
