#ifndef SETTINGS_H
#define SETTINGS_H

#include <QDialog>
#include <QColorDialog>

namespace Ui {
class Settings;
}

class Settings : public QDialog
{
    Q_OBJECT
    
public:
    explicit Settings(QWidget *parent = 0);
    //Settings variable
    bool HideAppCheckBox;
    bool  PlayStationRadioButton;
    QString PlayThisStationComboBox;
    bool PlayLastStationRadioButton;
    bool PlayStationAutomaticly;
    bool ShowStationsSystemTray;
    bool ShowSystemTrayMessage;
    bool HideOnMinimize;
    QString UILanguage;
    bool ShowWindowInStyleMode;
    QString StyleName;
    QString StyleLabel_a;
    QString StyleLabel_b;
    bool EnableVisualisation;
    int VisualisationLineWidth;
    int VisualisationOpacitySlider;
    QColor LeftChannelColor, RightChannelColor;
    int LeftChannelPosition, RightChannelPosition;
    bool UseLeftChannel, UseRightChannel;

    bool IconTheme_White;
    bool CoutModeChanged;
    bool CoatChanged;

    //Language Settings - Settings
    QString LangSettingsTitle;
    QString LangSettingsInfo;
    QString CancelButtonText;
    QString OKButtonText;
    QString ResetButtonText;
    QString LangStyleBox;
    QString LangStyle_label;
    QString CompositingManagerON;
    QString CompositingManagerOFF;
    QString mailto;
    QString website;
    QString websiteTips;
    QString LangERROR_NOCOATS;
    QString LangERROR_NOLANGS;
    QString LangStartupTab;
    QString LangLookAndFeelTab;
    QString LangLocalization;
    QString LangHideMainWindowCheckBox;
    QString PlayStationAutomaticly1;
    QString PlayStationRadioButton1;
    QString PlayLastStationRadioButton1;
    QString LangShowStationsSystemTray;
    QString LangShowSystemTrayMessage;
    QString LaguageGroupBox;
    QString label_localization;
    QString label_autostartapp;
    QString HideOnMinimizeCheckBoxText;

    QString LangVisualisation;
    QString LangVisualisationEnable;
    QString LangChannels;
    QString LangLeftChannel;
    QString LangRightChannel;
    QString LangAlpha;
    QString LangLineWidth;
    QString LangPositionText;

    QString IconThemeGroupBox;
    QString IconThemeWhite;
    QString IconThemeBlack;

    ~Settings();
    
private slots:


    void readSettings();
    void on_PlayStationRadioButton1_toggled(bool checked);
    void LoadStationsToAutoPlayList();
    void on_PlayThisStationComboBox1_currentIndexChanged(const QString &arg1);
    void ReadLanguage(QString Language);
    void on_PlayStationAutomaticly1_toggled(bool arg1);
    void SearchForStyleFiles();
    void SearchForLanguageFiles();
    void on_StyleBox_toggled(bool arg1);
    void on_StyleComboBox_activated(const QString &arg1);
    void on_LeftChannelColorPushButton_clicked();
    void on_RightChannelPushButton_clicked();

public slots:
    void ResetToDefault();
    void AcceptSettings();

private:
    Ui::Settings *ui;
};

#endif // SETTINGS_H
